<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreateTableUsuarios extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('usuarios', function (Blueprint $table) {
            $table->increments('id');
            $table->string('alias');
            $table->string('name');
            $table->string('pass');
            $table->string('email');
            $table->string('surname')->default("");
            $table->longText('description')->nullable();
            $table->string('avatar')->default("d_avatar.png");
            $table->longText('materies_mentor')->nullable();
            $table->longText('materies_student')->nullable();
            $table->integer('rating_mentor')->default(3);
            $table->integer('rating_student')->default(3);
            $table->integer('num_rating_mentor')->default(1);
            $table->integer('num_rating_student')->default(1);
            $table->string('city')->nullable();
            $table->boolean('student')->default(0);
            $table->boolean('mentor')->default(0);
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('usuarios');
    }
}
