package edu.uoc.perezdehitajesus.uocapplication;

import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.ImageView;
import android.widget.Toast;

import com.android.volley.RequestQueue;
import com.android.volley.toolbox.Volley;

public class AvatarActivity extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_avatar);

        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

        ImageView img1 = findViewById(R.id.imageView1);
        imageViewAddEventListener(img1);
        ImageView img2 = findViewById(R.id.image_login);
        imageViewAddEventListener(img2);
        ImageView img3 = findViewById(R.id.imageView3);
        imageViewAddEventListener(img3);
        ImageView img4 = findViewById(R.id.imageView4);
        imageViewAddEventListener(img4);
        ImageView img5 = findViewById(R.id.imageView5);
        imageViewAddEventListener(img5);
        ImageView img6 = findViewById(R.id.imageView6);
        imageViewAddEventListener(img6);
        ImageView img7 = findViewById(R.id.imageView7);
        imageViewAddEventListener(img7);
        ImageView img8 = findViewById(R.id.imageView8);
        imageViewAddEventListener(img8);
        ImageView img9 = findViewById(R.id.imageView9);
        imageViewAddEventListener(img9);
        ImageView img10 = findViewById(R.id.imageView10);
        imageViewAddEventListener(img10);
        ImageView img11 = findViewById(R.id.imageView11);
        imageViewAddEventListener(img11);
        ImageView img12 = findViewById(R.id.imageView12);
        imageViewAddEventListener(img12);
    }

    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return true;
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    public boolean onOptionsItemSelected(MenuItem item) {

        int id = item.getItemId();

        if (id == R.id.faqs) {
            Intent intent = new Intent(this, FaqsActivity.class);
            this.startActivity(intent);
            return true;
        }

        if (id == R.id.help) {
            Intent i = new Intent(Intent.ACTION_SEND);
            i.setType("message/rfc822");
            i.putExtra(Intent.EXTRA_EMAIL, new String[]{ getIntent().getStringExtra("jesusperezdehita@gmail.com")});
            i.putExtra(Intent.EXTRA_SUBJECT, "Contact Support User ID"+UserInfo.getUser_id()+" User:"+UserInfo.getUser_name()+" "+UserInfo.getUser_surname());
            i.putExtra(Intent.EXTRA_TEXT, "Introdueix la pregunta o incidència que tinguis detectat i ens posarem en seguida en contacte amb tu, gràcies.");
            try {
                startActivity(Intent.createChooser(i, "Enviant el correu..."));
            } catch (android.content.ActivityNotFoundException ex) {
                Toast.makeText(AvatarActivity.this, "No tens instal·lat cap client de correu com Gmail, etc.", Toast.LENGTH_SHORT).show();
            }
        }

        if (id == R.id.closeApp) {
            Intent intent = new Intent(this, LoginActivity.class);
            this.startActivity(intent);
            finishAffinity();
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    protected void imageViewAddEventListener(ImageView img){
        img.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                onSelectedAvatat(v);
            }
        });
    }

    protected void onSelectedAvatat(View v){
        RequestQueue queue = Volley.newRequestQueue(this);

        String selectedImage = "";
        switch (v.getId()){
            case R.id.imageView1 : selectedImage = "f_1.png";
            break;
            case R.id.image_login: selectedImage = "f_2.png";
                break;
            case R.id.imageView3 : selectedImage = "f_3.png";
                break;
            case R.id.imageView4 : selectedImage = "f_4.png";
                break;
            case R.id.imageView5 : selectedImage = "f_5.png";
                break;
            case R.id.imageView6 : selectedImage = "f_6.png";
                break;
            case R.id.imageView7 : selectedImage = "f_7.png";
                break;
            case R.id.imageView8 : selectedImage = "f_8.png";
                break;
            case R.id.imageView9 : selectedImage = "f_9.png";
                break;
            case R.id.imageView10 : selectedImage = "f_10.png";
                break;
            case R.id.imageView11 : selectedImage = "f_11.png";
                break;
            case R.id.imageView12 : selectedImage = "f_12.png";
                break;
            default: selectedImage = "d_avatar.png";
        }

        UserInfo.setUser_avatar(selectedImage);
        startActivity(new Intent(this, ProfileActivity.class));
    }
}
