package edu.uoc.perezdehitajesus.uocapplication;

import android.content.Context;
import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.Toast;

import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.JsonArrayRequest;
import com.android.volley.toolbox.JsonObjectRequest;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

public class LoginActivity extends AppCompatActivity implements Response.Listener<JSONObject>,Response.ErrorListener{

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_login);



        ImageView img = (ImageView) findViewById(R.id.contact_support);
        img.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                // your code here
                contactSupport(v);
            }
        });


    }

    public void goToMainLayout(final View v) {

        EditText useralias = (EditText)findViewById(R.id.login_alias);
        EditText userpass = (EditText)findViewById(R.id.login_pass);

        String alias = useralias.getText().toString();
        String pass = userpass.getText().toString();

        if (alias != null && !alias.equals("null") && !alias.equals("") && userpass != null && !userpass.equals("null") && !userpass.equals("")) {
            String url = "http://jesusperezdehita.es/api/loginMentoring?alias=" + alias + "&pass=" + pass;

            // Instantiate the RequestQueue.
            RequestQueue queue = Volley.newRequestQueue(this);

            // Request a string response from the provided URL.
            StringRequest stringRequest = new StringRequest(Request.Method.POST, url,
                    new Response.Listener<String>() {
                        @Override
                        public void onResponse(String response) {
                            Log.d("Response Object", response);

                            try {
                                JSONArray jsonArray = new JSONArray(response);
                                JSONObject obj = jsonArray.getJSONObject(0); //0 for just retrieving first object you can loop it
                                String user_id = obj.getString("user_id");
                                String user_avatar = obj.getString("user_avatar");
                                if (!user_id.isEmpty()) {
                                    try {
                                        UserInfo.setUser_id(user_id);
                                        UserInfo.setUser_avatar(user_avatar);
                                    } catch (Error e) {
                                        Log.d("error", e.toString());
                                    }
                                    onSuccessLogin();
                                } else {
                                    Context context = getApplicationContext();
                                    CharSequence text = "Usuari o contrasenya incorrecte1";
                                    int duration = Toast.LENGTH_SHORT;
                                    Toast toast = Toast.makeText(context, text, duration);
                                    toast.show();
                                }
                            } catch (JSONException e) {
                                Context context = getApplicationContext();
                                CharSequence text = "Usuari o contrasenya incorrecte";
                                int duration = Toast.LENGTH_SHORT;
                                Toast toast = Toast.makeText(context, text, duration);
                                toast.show();
                                e.printStackTrace();
                            }
                        }
                    }, new Response.ErrorListener() {
                @Override
                public void onErrorResponse(VolleyError error) {
                    Log.d("Error Volley", "That didn't work!");
                    Context context = getApplicationContext();
                    CharSequence text = "Error de login, revisa que estiguin totes les dades i que siguin correctes, gràcies.";
                    int duration = Toast.LENGTH_LONG;
                    Toast toast = Toast.makeText(context, text, duration);
                    toast.show();
                }
            });

            // Add the request to the RequestQueue.
            queue.add(stringRequest);
        }else{
            Context context = getApplicationContext();
            CharSequence text = "Revisa que estiguin totes les dades i que siguin correctes, gràcies.";
            int duration = Toast.LENGTH_SHORT;
            Toast toast = Toast.makeText(context, text, duration);
            toast.show();
        }
    }

    public void onSuccessLogin(){
        final String urlUsers = "http://jesusperezdehita.es/api/usuarios";
        final String urlMateries = "http://jesusperezdehita.es/api/materies";

        // Instantiate the RequestQueue.
        RequestQueue queue = Volley.newRequestQueue(this);

        // Request a string response from the provided URL.
        StringRequest usersRequest = new StringRequest(Request.Method.GET, urlUsers,
                new Response.Listener<String>() {
                    @Override
                    public void onResponse(String response) {
                        Log.d("url usuarios ",urlUsers);

                        try {
                            JSONArray jsonArrayUsers = new JSONArray(response);

                            UserInfo.setUsers_app(jsonArrayUsers);

                            JSONObject obj = jsonArrayUsers.getJSONObject(0); //0 for just retrieving first object you can loop it
                            UserInfo.setUser_name(obj.getString("name"));
                            UserInfo.setUser_surname(obj.getString("surname"));

                        } catch (JSONException e) {
                            e.printStackTrace();
                        }

                    }
                }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {
                Log.d("Error Volley","That didn't work!");
            }
        });
        queue.add(usersRequest);

        StringRequest materiesRequests = new StringRequest(Request.Method.GET, urlMateries,
                new Response.Listener<String>() {
                    @Override
                    public void onResponse(String response) {
                        Log.d("url materies ",urlMateries);
                        try {
                            JSONArray jsonArrayMateries = new JSONArray(response);
                            UserInfo.setMateries_app(jsonArrayMateries);
                        } catch (JSONException e) {
                            e.printStackTrace();
                        }

                    }
                }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {
                Log.d("Error Volley","That didn't work!");
            }
        });
        queue.add(materiesRequests);
        startActivity(new Intent(this, HomeActivity.class));
    }

    public void goToRegisterLayout(final View v) {
        startActivity(new Intent(this, RegisterActivity.class));
    }

    public void contactSupport(final View v) {
        Intent i = new Intent(Intent.ACTION_SEND);
        i.setType("message/rfc822");
        i.putExtra(Intent.EXTRA_EMAIL, new String[]{getIntent().getStringExtra("jesusperezdehita@gmail.com")});
        i.putExtra(Intent.EXTRA_SUBJECT, "Contact Support - Pàgina d'inici");
        i.putExtra(Intent.EXTRA_TEXT, "Introdueix la pregunta o incidència que tinguis detectat i ens posarem en seguida en contacte amb tu, gràcies.");
        try {
            startActivity(Intent.createChooser(i, "Enviant el correu..."));
        } catch (android.content.ActivityNotFoundException ex) {
            Toast.makeText(LoginActivity.this, "No tens instal·lat cap client de correu com Gmail, etc.", Toast.LENGTH_SHORT).show();
        }
    }

    @Override
    public void onErrorResponse(VolleyError error) {

    }

    @Override
    public void onResponse(JSONObject response) {

    }

    public void goToExit(final View v) {
        moveTaskToBack(true);
        android.os.Process.killProcess(android.os.Process.myPid());
        System.exit(1);
        finishAffinity();
    }
}
