package edu.uoc.perezdehitajesus.uocapplication;

import android.content.Intent;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.RatingBar;
import android.widget.TextView;
import android.widget.Toast;

import edu.uoc.perezdehitajesus.uocapplication.modelClass.StudentContent;

public class StudentDetailFragment extends Fragment {

    public static final String ARG_ITEM_ID = "item_id";

    private StudentContent.StudentItem mItem;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (getArguments().containsKey(ARG_ITEM_ID)) {
            mItem = StudentContent.ITEM_MAP.get(getArguments().getString(ARG_ITEM_ID));
        }
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,Bundle savedInstanceState) {
        View rootView = inflater.inflate(R.layout.student_detail, container, false);
        if (mItem != null) {

            String uri = "@drawable/" + mItem.picture.substring(0, mItem.picture.lastIndexOf('.'));

            int imageResource = getResources().getIdentifier(uri, null, getContext().getPackageName());
            Drawable res = getResources().getDrawable(imageResource);
            ((ImageView) rootView.findViewById(R.id.student_picture)).setImageDrawable(res);
            ((RatingBar) rootView.findViewById(R.id.ratingBar)).setRating(mItem.rating_student);
            ((TextView) rootView.findViewById(R.id.student_alias)).setText(mItem.alias);
            ((TextView) rootView.findViewById(R.id.student_name)).setText(mItem.name);
            ((TextView) rootView.findViewById(R.id.student_surname)).setText(mItem.surname);
            ((TextView) rootView.findViewById(R.id.student_email)).setText(mItem.email);
            ((TextView) rootView.findViewById(R.id.student_materies)).setText(mItem.materies);
            ((TextView) rootView.findViewById(R.id.student_description)).setText(mItem.description);
        }

        Button valorar = rootView.findViewById(R.id.valorar);
        valorar.setOnClickListener(ValorarButtonClickListener);

        Button contact = rootView.findViewById(R.id.contactar);
        contact.setOnClickListener(ContactarButtonClickListener);

        return rootView;
    }

    private View.OnClickListener ValorarButtonClickListener = new View.OnClickListener() {
        public void onClick(View v) {
            Intent intent = new Intent(getActivity(), UserSelected.class);
            intent.putExtra("user_type", "student");
            intent.putExtra("id",mItem.id );
            intent.putExtra("name",mItem.name );
            intent.putExtra("surname",mItem.surname );
            intent.putExtra("rating", mItem.rating_student);
            startActivity(intent);
        }
    };

    private View.OnClickListener ContactarButtonClickListener = new View.OnClickListener() {
        public void onClick(View v) {
            Intent i = new Intent(Intent.ACTION_SEND);
            i.setType("message/rfc822");
            i.putExtra(Intent.EXTRA_EMAIL, new String[]{mItem.email});
            i.putExtra(Intent.EXTRA_SUBJECT, "Contacte de "+ UserInfo.getUser_name()+ "" + UserInfo.getUser_surname() +" amb "+mItem.name+" "+mItem.surname);
            i.putExtra(Intent.EXTRA_TEXT, "Introdueix la pregunta o incidència que tinguis detectat i ens posarem en seguida en contacte amb tu, gràcies.");
            try {
                startActivity(Intent.createChooser(i, "Enviant el correu..."));
            } catch (android.content.ActivityNotFoundException ex) {
                Toast.makeText(getContext().getApplicationContext(), "No tens instal·lat cap client de correu com Gmail, etc.", Toast.LENGTH_SHORT).show();
            }
        }
    };
}
