package edu.uoc.perezdehitajesus.uocapplication.modelClass;

import android.util.Log;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import edu.uoc.perezdehitajesus.uocapplication.UserInfo;

public class MentorContent {

    public static final List<MentorItem> ITEMS = new ArrayList<MentorItem>();

    public static final Map<String, MentorItem> ITEM_MAP = new HashMap<String, MentorItem>();

    static {
        Log.d("object --------- ", UserInfo.getUsers_app().toString());

        JSONArray jsonStr = UserInfo.getUsers_app();

        try {
            for (int i = 0 ; i < jsonStr.length(); i++) {
                JSONObject obj = jsonStr.getJSONObject(i);
                if((UserInfo.getUser_id() != obj.getString("id"))){
                    if(Integer.parseInt(obj.getString("mentor")) == 1){
                        addItem(createMentorItem(Integer.parseInt( obj.getString("id")), obj.getString("alias"), obj.getString("name"), obj.getString("surname"),  obj.getString("description"), obj.getString("avatar"), obj.getString("materies_mentor"), obj.getString("city"),  obj.getString("email"), obj.getInt("rating_mentor")));
                    }
                }
            }

        } catch (JSONException e) {
            e.printStackTrace();
        }
    }

    private static void addItem(MentorItem item) {
        ITEMS.add(item);
        ITEM_MAP.put(item.id, item);
    }

    private static MentorItem createMentorItem(int position,  String alias, String name, String surname, String description, String picture, String materies, String city, String email, Integer rating_mentor) {
        return new MentorItem(String.valueOf(position), description, makeDetails(position), alias, name, surname, picture, description, materies, city, email, rating_mentor);
    }

    private static String makeDetails(int position) {
        StringBuilder builder = new StringBuilder();
        builder.append("Details about Item: ").append(position);
        builder.append("\nMore details information here.");
        return builder.toString();
    }

    public static class MentorItem {
        public final String id, alias, name, surname, picture, description, content, details, city, materies, email;
        public final Integer  rating_mentor;

        public MentorItem(String id, String content, String details, String alias, String name, String surname, String picture, String description, String materies, String city, String email, Integer rating_mentor) {
            this.id = id;
            this.alias = alias;
            this.name = name;
            this.surname = surname;
            this.content = content;
            this.details = details;
            this.picture = picture;
            this.description = description;
            this.materies = materies;
            this.city = city;
            this.email = email;
            this.rating_mentor = rating_mentor;
        }

        public String getId() {
            return id;
        }

        public String getCity() {
            return city;
        }

        public String getMateries() {
            return materies;
        }

        public String getName() {
            return name;
        }

        public String getSurname() {
            return surname;
        }

        public String getPicture() {
            return picture;
        }

        public String getDescription() {
            return description;
        }

        public String getContent() {
            return content;
        }

        public String getDetails() {
            return details;
        }

        @Override
        public String toString() {
            return content;

        }
    }
}